Home | History | Annotate | Download | only in rbind
      1 #!/bin/bash
      2 
      3 #
      4 # Copyright (c) International Business Machines  Corp., 2005
      5 # Author: Avantika Mathur (mathurav (at] us.ibm.com)
      6 #
      7 # This library is free software; you can redistribute it and/or
      8 # modify it under the terms of the GNU Lesser General Public
      9 # License as published by the Free Software Foundation; either
     10 # version 2.1 of the License, or (at your option) any later version.
     11 #
     12 # This library is distributed in the hope that it will be useful,
     13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
     14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
     15 # Lesser General Public License for more details.
     16 #
     17 # You should have received a copy of the GNU Lesser General Public
     18 # License along with this library; if not, write to the Free Software
     19 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
     20 #
     21 
     22 SETS_DEFAULTS="${TCID=test39} ${TST_COUNT=1} ${TST_TOTAL=1}"
     23 declare -r TCID
     24 declare -r TST_COUNT
     25 declare -r TST_TOTAL
     26 export TCID TST_COUNT TST_TOTAL
     27 
     28 tst_resm TINFO "***************TEST39***************"
     29 tst_resm TINFO "rbind: private to private - with unclonable children."
     30 tst_resm TINFO "************************************"
     31 
     32 . "${FS_BIND_ROOT}/bin/setup" || (tst_resm TWARN "Setup of rbind/test39 failed" && tst_exit)
     33 export result=0
     34 
     35 
     36 
     37 trap 'ERR=$? ; ERR_MSG="caught error near: ${BASH_SOURCE[0]}:${FUNCNAME[0]}:${LINENO}:$_ (returned ${ERR})"; break' ERR
     38 
     39 while /bin/true ; do
     40 	# This loop is for error recovery purposes only
     41 
     42 
     43 	mkdir parent1 parent2
     44 	"${FS_BIND_ROOT}/bin/makedir" unclone parent1/child1
     45 
     46 	mount --bind "$disk1" parent1/child1
     47 
     48 	mount --rbind parent1 parent2
     49 
     50 	check parent1 parent2
     51 	check -n parent1/child1 parent2/child1
     52 
     53 	break
     54 done
     55 trap 'ERR=$? ; tst_resm TWARN "rbind/test39: caught error near: ${BASH_SOURCE[0]}:${FUNCNAME[0]}:${LINENO}:$_ (returned ${ERR})"' ERR
     56 if [ -n "${ERR_MSG}" ]; then
     57 	tst_resm TWARN "rbind/test39: ${ERR_MSG}"
     58 	ERR_MSG=""
     59 	result=$ERR
     60 fi
     61 trap '' ERR
     62 {
     63 	umount parent1/child1
     64 	umount parent1/child1
     65 	umount parent2
     66 
     67 	rm -rf parent* share*
     68 	cleanup
     69 } >& /dev/null
     70 if [ $result -ne 0 ]
     71 then
     72 	tst_resm TFAIL "rbind/test39: FAILED: rbind: private to private - with unclonable children."
     73 	exit 1
     74 else
     75 	tst_resm TPASS "rbind/test39: PASSED"
     76 	exit 0
     77 fi
     78 tst_exit
     79